package com.example.lifelinetest;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;

import android.os.Bundle;
import android.provider.ContactsContract;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.Toast;

import com.example.lifelinetest.modules.Patient;
import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.OnFailureListener;
import com.google.android.gms.tasks.OnSuccessListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.database.DataSnapshot;
import com.google.firebase.database.DatabaseError;
import com.google.firebase.database.DatabaseReference;
import com.google.firebase.database.FirebaseDatabase;
import com.google.firebase.database.ValueEventListener;

import java.util.ArrayList;
import java.util.List;

public class add_patient extends AppCompatActivity {
    EditText id,name,wardNumber,age,deviceId;
    Spinner bloodType;
    Button submit;
    List<String> idList = new ArrayList<>();
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_add_patient);
        id = findViewById(R.id.et_id);
        name = findViewById(R.id.et_nurse_name);
        wardNumber = findViewById(R.id.et_wardNumber);
        age = findViewById(R.id.et_age);
        bloodType = findViewById(R.id.spinner);
        deviceId = findViewById(R.id.et_deviceId);
        submit = findViewById(R.id.btn_submit);
        getId();

        submit.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                String Id = id.getText().toString().trim();
                String Name = name.getText().toString().trim();
                String WardNumber = wardNumber.getText().toString().trim();
                int Age = Integer.parseInt(age.getText().toString().trim());
                String BloodType = String.valueOf(bloodType.getSelectedItem());
                String DeviceId = deviceId.getText().toString().trim();
                Patient patient = new Patient(Id, Name, WardNumber, Age, BloodType, DeviceId);
                uploadPatient(patient);
            }
        });
    }

    private void getId(){
        DatabaseReference mId = FirebaseDatabase.getInstance().getReference().child(FirebaseAuth.getInstance()
                .getCurrentUser().getUid()).child("index");
        ValueEventListener idListener = new ValueEventListener() {
            @Override
            public void onDataChange(@NonNull DataSnapshot dataSnapshot) {
                idList = (List<String>) dataSnapshot.getValue();
            }

            @Override
            public void onCancelled(@NonNull DatabaseError databaseError) {
                Log.w("Tag:", "loadPost:onCancelled", databaseError.toException());
                // [START_EXCLUDE]
                Toast.makeText(add_patient.this, "Failed to load post.",
                        Toast.LENGTH_SHORT).show();
            }
        };
        mId.addListenerForSingleValueEvent(idListener);
    }

    private void uploadPatient(Patient patient) {
        DatabaseReference mDatabase = FirebaseDatabase.getInstance().getReference().child("patients").child(patient.id);
        mDatabase.setValue(patient);
        idList.add(patient.id);
        DatabaseReference mId = FirebaseDatabase.getInstance().getReference().child(FirebaseAuth.getInstance()
                .getCurrentUser().getUid()).child("index");
        mId.setValue(idList).addOnSuccessListener(new OnSuccessListener<Void>() {
            @Override
            public void onSuccess(Void aVoid) {
                Toast.makeText(add_patient.this, "Patient added successfully.", Toast.LENGTH_SHORT).show();
            }
        });
    }
}

